<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head> <title>Mein Gstebuch</title> 
<style type="text/css">
<!--
.Stil1 {font-family: Arial, Helvetica, sans-serif}
body,td,th {
	color: #FFFFFF;
}
body {
	background-color: #006699;
}
a:link {
	color: #FFFFFF;
	text-decoration: underline;
}
a:visited {
	text-decoration: underline;
	color: #FFFFFF;
}
a:hover {
	text-decoration: none;
	color: #FFFFFF;
}
a:active {
	text-decoration: underline;
	color: #333333;
}
-->
</style>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" /></head>
<%-- Importieren von Java-Klassenbibliotheken --%> 
<%@page import="java.util.*"%>
<%@page import="java.io.*"%>
<%@page import="java.text.*"%>


<%-- Deklaration von Java-Klassen --%>
<%! 
//Java-Klasse zur Serialisierung und Deserialisierung
class ObjektDatei
{
	private String Dateiname;
	//Konstruktor
	public ObjektDatei(String Dateiname)
	{
	this.Dateiname = Dateiname;
	}
	//Operationen
	public void speichereObjekt(Object einObjekt)
	{
		try
		{
			ObjectOutputStream AusgabeDatei =
			new ObjectOutputStream(new FileOutputStream(Dateiname));
			AusgabeDatei.writeObject(einObjekt);
			AusgabeDatei.close();
		}
		catch (IOException e) 
		{System.out.println("Fehler beim Dateispeichern: "+e);}
	}
	public Object leseObjekt()
	{
		Object einObjekt = null;
		try
		{
			ObjectInputStream EingabeDatei =
			new ObjectInputStream(new FileInputStream(Dateiname));
			einObjekt = EingabeDatei.readObject();
			EingabeDatei.close();
		}
		catch (IOException e1) {}
		catch (ClassNotFoundException e2) {}
		return einObjekt;
	}
}

//Klasse zur Verwaltung einzelner Gstebucheintrge
class GaesteEintrag implements Serializable
{ 
	private String name, email, homepage, comment, today;
	//Konstruktor
	GaesteEintrag(String name, String email, String homepage, 
	String comment, String today)
	{
	this.name = name;
	this.email = email;
	this.homepage = homepage;
	this.comment = comment;
	this.today = today;
	}
	//get-Operationen
	String getName(){return name;}
	String getEmail(){return email;}
	String getHomepage(){return homepage;}
	String getComment(){return comment;}
	String getToday(){return today;}
}

//Container zur Verwaltung der Gstebucheintrge
//Als Datenstruktur wird ein Vektor verwendet
class GaesteBuch implements Serializable
{
	private Vector einVektor = new Vector();
	//Operationen
	void anfuegen(GaesteEintrag einEintrag) 
	{
		einVektor.addElement(einEintrag);
	}
	GaesteEintrag getEintrag(int index)
	{
		return (GaesteEintrag)einVektor.elementAt(index);
	}
	int getAnzahlEintraege()
	{
		return einVektor.size();
	}
}
//Ende der Deklarationen von Klassen
%>
<body>
<blockquote>
  <blockquote>
      <br/>
      <h1><span class="Stil1">
      <%
//JSP-Skriptlet-Code
//GaestebuchDatei lesen
ObjektDatei meinSpeicher = new ObjektDatei("c:/temp/Gaestebuchdatei");
GaesteBuch einGaesteBuch = (GaesteBuch)meinSpeicher.leseObjekt();
//Wenn Datei noch nicht vorhanden, dann anlegen
if(einGaesteBuch == null) einGaesteBuch = new GaesteBuch();


//Auslesen des HTML-Formulars
String name = request.getParameter("name");
String email = request.getParameter("email");
String homepage = request.getParameter("homepage");
String comment = request.getParameter("eintrag");
//Aktuelles Datum 
Date date = new Date();
//Deutsches Datumsformat whlen
DateFormat formatDatumDeutsch = 
DateFormat.getDateInstance(DateFormat.DEFAULT,Locale.GERMANY);
String date_str = formatDatumDeutsch.format(date);
//Aktuelle Zeit
Date time = new Date();
//Deutsches Zeitformat whlen
DateFormat formatZeitDeutsch = 
DateFormat.getTimeInstance(DateFormat.DEFAULT,Locale.GERMANY);
String time_str = formatZeitDeutsch.format(time);
String today  = date_str + " " + time_str;

//Prfen, ob ein Daten eingegeben wurden
//Hier nur Prfung auf Name
if (name != null && name.length() > 0)
{ 
	//Eintrag in Klasse Gstebuch
	einGaesteBuch.anfuegen
	(new GaesteEintrag(name,email,homepage,comment,today));
	//Speichern des Gstebuchs
	meinSpeicher.speichereObjekt(einGaesteBuch);
}
%>
      <b>Mein Gstebuch</b><br/>
      </span> </h1>
  <hr>
      <span class="Stil1">
      <% 
//Anzeige des kompletten Gstebuchs
for (int i=0; i < einGaesteBuch.getAnzahlEintraege(); i++)
	{ 
		GaesteEintrag einEintrag = einGaesteBuch.getEintrag(i);
%>
      Am <%=einEintrag.getToday()%> schrieb:</br>
      <%=einEintrag.getName()%></br>
      mit der E-Mail: <%=einEintrag.getEmail()%></br>
      und der Homepage: <%=einEintrag.getHomepage()%></br>
      diesen Eintrag: <%=einEintrag.getComment()%></br>
              </span>
      <hr>
      <span class="Stil1">
      <%}%>
              </span>
    </p>
    <h3 class="Stil1"><a href="index.html"><strong>Zur Startseite    </strong></a></h3>
  </blockquote>
</blockquote>
</body>